# class Bundler::Retry

General purpose class for retrying code that may fail

### Attributes

current_run[RW]
name[RW]
total_runs[RW]

### Public Class Methods

attempts()
Alias for: default_attempts
default_attempts() click to toggle source

    # File lib/bundler/retry.rb, line 9
    def default_attempts
      default_retries + 1
    end

Also aliased as: attempts
default_retries() click to toggle source

    # File lib/bundler/retry.rb, line 14
    def default_retries
      Bundler.settings[:retry]
    end

new(name, exceptions = nil, retries = self.class.default_retries) click to toggle source

    # File lib/bundler/retry.rb, line 19
    def initialize(name, exceptions = nil, retries = self.class.default_retries)
      @name = name
      @retries = retries
      @exceptions = Array(exceptions) || []
      @total_runs = @retries + 1 # will run once, then upto attempts.times
    end

### Public Instance Methods

attempt(&block) click to toggle source

    # File lib/bundler/retry.rb, line 26
    def attempt(&block)
      @current_run = 0
      @failed      = false
      @error       = nil
      run(&block) while keep_trying?
      @result
    end

Also aliased as: attempts
attempts(&block)
Alias for: attempt

### Private Instance Methods

fail_attempt(e) click to toggle source

    # File lib/bundler/retry.rb, line 45
    def fail_attempt(e)
      @failed = true
      if last_attempt? || @exceptions.any? {|k| e.is_a?(k) }
        Bundler.ui.info "" unless Bundler.ui.debug?
        raise e
      end
      return true unless name
      Bundler.ui.info "" unless Bundler.ui.debug? # Add new line incase dots preceded this
      Bundler.ui.warn "Retrying #{name} due to error (#{current_run.next}/#{total_runs}): #{e.class} #{e.message}", Bundler.ui.debug?
    end

keep_trying?() click to toggle source

    # File lib/bundler/retry.rb, line 56
    def keep_trying?
      return true  if current_run.zero?
      return false if last_attempt?
      return true  if @failed
    end

last_attempt?() click to toggle source

    # File lib/bundler/retry.rb, line 62
    def last_attempt?
      current_run >= total_runs
    end

run(&block) click to toggle source

    # File lib/bundler/retry.rb, line 37
    def run(&block)
      @failed      = false
      @current_run += 1
      @result = block.call
    rescue => e
      fail_attempt(e)
    end